#include <LiquidCrystal.h>
#include <OneWire.h>
#include <EEPROM.h>
#include <Servo.h>

int butPin = 0;            // вход кнопок
int buzzer = 35;            // выход динамика
int exitMenu = 1;          // выход из меню
int butPush = 0;           // код нажатой кнопки
int butRel=1;              // нажата ли сейчас кнопка
int val;                   // знач. АЦП при нажатой кнопке
int menu=0;                // текущий экран
int port1=22;               //РАЗГОННЫЙ ТЕН
int port2=24;               //РАБОЧИЙ ТЕН
int port3=26;               //КЛАПАН ОХЛАЖДАЮЩЕЙ ЖИДКОСТИ
int port4=28;               //КЛАПАН отбора голов
int port5=30;               //КЛАПАН отбора паровыеголовы/тело


byte port1_stat=1;    // статус порта (включен/выключен
byte port2_stat=1;    //И ЧТО-БЫ НЕБЫЛО МУСОРА В ЗНАЧЕНИИ ПОРТА
byte port3_stat=1;
byte port4_stat=1;  
byte port5_stat=1; 

byte f=0;                     // счётчик процессов
byte i;                    // счетчик
byte n;                    // счетчик
byte m=0;                   // счетчик
byte t=0;                   // счетчик
float X;                // температура замерянная для работы
float J;             //
float V=1;        //плюс к замерянной температуре отбора
float Z=2;     // плюс значение порога стопа
float Q=X+Z;      // значение порога конца процесса
   byte data[8];              // для хранения данных от датчика
unsigned long timer=0;     // таймер 
unsigned long procStTime=0;// время начала текущего процесса
unsigned long StTime=0;    // время запуска программы
float Tr1=30;             // КУБ
float Tr2=33;             //1/3 СМ КОЛОННЫ
float Tr3=33;             //охлаждающая жидкость
float Tr4=33;             //ВЕРХНЯЯ ЦАРГА
int Pz1=1;                 // работа на себя пауз в минутах
int Pz2=1;              //головы
int Pz3=1;          // пока пусто////
int Pz4=1;         //первый затоп /реально 3 мин
int Pz5=1;         //первое орашение/ реально 2 мин
int Pz6=1;         //второй затоп
int Pz7=1;         //второе орашение
int Pz8=1;         //третий затоп
int Pz9=1;         //третее орашение
int Pz10=1;        //полутело
int butval[8]={0,1023,817,602,407,203,0,0};   // АЦП кнопок
byte butsens=20;           // чувствительность кнопок
int keyvalue=0;            // для хранения АЦП при калибровке
boolean keysound=0;        // включен ли звук кнопок
int process=0;             // номер текущего процесса
boolean running = false;   // состояние программы
byte TotalDS=0;   // число найденых датчиков на линии
byte addr[4][8] = {
   {0,0,0,0,0,0,0,0},
   {0,0,0,0,0,0,0,0},
   {0,0,0,0,0,0,0,0},
   {0,0,0,0,0,0,0,0},
};  
float Tp[]={0,0,0,0};  
float T[]={0,0,0,0}; 
                   //T[0]-КУБ
                   //T[1]-20 СМ НАЧАЛО КОЛОННЫ
                   //T[?]-ВТОРАЯ ЦАРГА
                   //T[2]-ОХЛАЖДАЮЩАЯ ЖИДКОСТЬ
byte Stop=0;  
float sr=80;       //начальное положение сервопривода/закрыта заслонка/
float sX=40;      //положение сервопривода при отборе/плностью открыта заслонка/
 

OneWire  ds(38);            // на этот пин подключен DS
LiquidCrystal lcd(8, 9, 4, 5, 6, 7); //инициализация LCD


Servo myservo;   
boolean servo = false; // servo не используется по умолчанию

void setup()
{
  myservo.attach(37 );
  lcd.begin(2, 16);
  Serial.begin(9600);
  pinMode(port1, OUTPUT);     
  pinMode(buzzer, OUTPUT);
  pinMode(port2,  OUTPUT);
  pinMode(port3, OUTPUT);
  pinMode(port4 , OUTPUT);
  pinMode(port5 , OUTPUT);
 
   if (analogRead(butPin) <  1000) { // процедура калибровки
    lcd.print("Kalibrovka");
    lcd.setCursor(0,1);
    delay(3000);
    for ( i = 1; i < 6; i++) {
    lcd.clear();
    lcd.print("Nagmite ");
    lcd.print(i, DEC);
    while (analogRead(butPin) > 1000) {};
    button ();
    butval[i]=val;
    lcd.clear();
    lcd.setCursor(0,1);
    lcd.print(i, DEC);
    lcd.print(" ");
    lcd.print(butval[i], DEC);
    EEPROM.write(224+i*2,butval[i]/4); // по 2 байта на значение начиная с 224
    EEPROM.write(225+i*2,butval[i]%4);
    delay(1000);
    }
  }
  
  else { // читаем АЦП кнопок
    for ( i = 0; i < 8; i++) {
      butval[i] = EEPROM.read(224+i*2)*4+EEPROM.read(225+i*2);
    }
  }
  read_DS();  //считываем адреса датчиков из памяти
  keysound = EEPROM.read(241);
  butsens = EEPROM.read(242); if (butsens < 5 || butsens > 100) { butsens = 20;}
  tone(buzzer, 1000);
  lcd.print("buhlovodam privet");
  
}


byte read_DS() {
  for (n=0; n<4; n++) {
    for (i=0; i<8; i++) {
      addr[n][i] = EEPROM.read(128+n*8+i);
    }
  }
  return 0;
}


void loop()
       
{
 
    ds.reset();
    ds.write(0xCC,1);          // пропуск ROM
    ds.write(0x44,1);          // запускаем конвертацию
    for( n = 1; n < 90; n++) { //ждем 900 мс
      delay(10);            
      if (analogRead(butPin) < 1000 && butRel) { Menu(button ()); } //периодически проверяя не нажата ли кнопка
      if (analogRead(butPin) > 1000) {butRel=1;} //периодически проверяя не нажата ли кнопка
    }
    
    
    ///////////////////////////
      for( n = 0; n < 4; n++) {
      ds.reset();
      ds.select(addr[n]);
      ds.write(0xBE);         // считываем ОЗУ датчика
      for ( i = 0; i < 9; i++) {data[i] = ds.read();} // обрабатываем 9 байт
      Tp[n] = float((data[1] << 8) + data[0])/16;     // высчитываем температуру :)
      if (Tp[n] == 85) {} else {T[n]=Tp[n];}         // это для того, чтобы при глюке датчика (обычно при переключениях 
        // выдача температуры 85 град не приводила к переходу на другой шаг программы
      }
   
    timer=millis()/1000;         // текущее время в сек.
         boolean servo = true;
     
          // myservo.write(20);
        {
          port1_stat=1;
        port2_stat=1;
       port3_stat=1;
       port4_stat=1;
       port5_stat=1;
      digitalWrite(port2,port2_stat);
     digitalWrite(port3,port3_stat);
     digitalWrite(port4,port4_stat);
     digitalWrite(port1,port1_stat);
     digitalWrite(port5,port5_stat);
     }
         
  if (Stop) {running=0;}
    
    if (running) {
    switch (process) {
      case 0:
       
        running=0;
        for ( i = 0; i < 5; i++) {
        tone(buzzer, 1000);
        delay(500);
        noTone(buzzer);
        delay(500);
        }
      break; 
     
    
case 1:    //закипаем,по Т2 пошли на следующий шаг
         myservo.write(sr);     //заслонка пара закрыта
          
     if (T[1]<27) {port1_stat=0;    //если Т<50 разгонный тэн включён
    
       port2_stat=1;                //рабочий тэн отключён
       port3_stat=1;                //клапан охл.жидкости закрыт
       port4_stat=1;                //клапан отбора головзакрыт
       port5_stat=1;  }               //клапан пароголов/тела закрыт
       
     else {
       
       process++;
       procStTime=timer;
       
     }
       case 2:   //1 затопление
     
      myservo.write(sr);//заслонка пара закрыта
      port3_stat=0;//вода включена
      port1_stat=0;//разгонный тэн включён
      port2_stat=1;//рабочий тен отключён
      port4_stat=1;//клапан голов закрыт
      port5_stat=1;//клапан пароголов/тело закрыт
     if (procStTime+Pz4*60 < timer) {process++;procStTime=timer;} //таймер Pz4
      else {
            if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}//если нет остановились
            
           }
                             
            break;
             
             case 3:   //1 орашение
     
      myservo.write(sr);//заслонка пара закрыта
      port3_stat=0;//вода включена
      port1_stat=1;//разгонный тэн отключён
      port2_stat=1;//рабочий тен отключён
      port4_stat=1;//клапан голов закрыт
      port5_stat=1;//клапан пароголов/тело закрыт
     if (procStTime+Pz5*60 < timer) {process++;procStTime=timer;} //таймер Pz5
      else {
            if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}//если нет остановились
           
           }
            break;
            
            case 4:   //2 затопление
     
      myservo.write(sr);//заслонка пара закрыта
      port3_stat=0;//вода включена
      port1_stat=0;//разгонный тэн включён
      port2_stat=1;//рабочий тен отключён
      port4_stat=1;//клапан голов закрыт
      port5_stat=1;//клапан пароголов/тело закрыт
     if (procStTime+Pz6*60 < timer) {process++;procStTime=timer;} //таймер Pz6
      else {
            if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}//если нет остановились
           
           }
                              
            break;
            
            
            case 5:   //2 орашение
     
      myservo.write(sr);//заслонка пара закрыта
      port3_stat=0;//вода включена
      port1_stat=1;//разгонный тэн отключён
      port2_stat=1;//рабочий тен отключён
      port4_stat=1;//клапан голов закрыт
      port5_stat=1;//клапан пароголов/тело закрыт
     if (procStTime+Pz7*60 < timer) {process++;procStTime=timer;} //таймер Pz7
      else {
            if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}//если нет остановились
           }
                              
            break;
            
            case 6:   //3 затопление
     
      myservo.write(sr);//заслонка пара закрыта
      port3_stat=0;//вода включена
      port1_stat=0;//разгонный тэн включён
      port2_stat=1;//рабочий тен отключён
      port4_stat=1;//клапан голов закрыт
      port5_stat=1;//клапан пароголов/тело закрыт
     if (procStTime+Pz9*60 < timer) {process++;procStTime=timer;} //таймер Pz8
      else {
            if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}//если нет остановились
           }
                              
            break;
            
            case 7:   //3 орашение
     
      myservo.write(sr);//заслонка пара закрыта
      port3_stat=0;//вода включена
      port1_stat=1;//разгонный тэн отключён
      port2_stat=1;//рабочий тен отключён
      port4_stat=1;//клапан голов закрыт
      port5_stat=1;//клапан пароголов/тело закрыт
     if (procStTime+Pz9*60 < timer) {process++;procStTime=timer;} //таймер Pz9
      else {
            if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}//если нет остановились
           }
                              
            break;
            
     
     case 8:   //работаем на себяPz1 минут
     
     myservo.write(sr);                   //заслонка пара закрыта
     port1_stat=1;         //разгонный тэн отключён
      port2_stat=0;        //рабочий тэн включён
      port3_stat=0;        //вода включена
     port4_stat=1;         //клапан отбора голов закрыт
     port5_stat=1;         //клапан пароголов/тело закрыт
    
      if (procStTime+Pz1*60 < timer) {process++;procStTime=timer;} //таймер Pz1
      else {
           
           if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}
             }
            break;
     
    /* case 3:   //работаем на  себя короткоеPz1 минут
     //закипели,разгонный тэн отключили,включили подачу охл.жидкости.
        if (f<1){ process++;} //если температура охл.жидкости в норме,рабочий тен включён
           else {  myservo.write(sr);                   //заслонка пара закрыта
     port1_stat=1;       //разгонный тэн отключён
     port4_stat=1;       //клапан отбора голов закрыт
     if (procStTime+Pz3*60 < timer) {process++;} //таймер Pz3
      else {
           
           if (T[2]<=Tr3){ port2_stat=0;} //если температура охл.жидкости в норме,рабочий тен включён
           else { Stop=1;}
            if (T[0]<=Tr1){ port2_stat=0;}//если температура куба меньшеТr1 рабочий тен включён
            else { Stop=2;}
             if (T[1]>=5){ port3_stat=0;}//если температура 1/3 царги больше50С клапан охл.жидк. включён
            else { port3_stat=1;}
           
            }             
          }                  
                          
      
           
     break;*/
 
     case 9:   //отбираем головыPz2 минут
     
     myservo.write(sr);    //заслонка пара закрыта
     port1_stat=1;         //разгонный тэн отключён
      port2_stat=0;        //рабочий тэн включён
      port3_stat=0;        //вода включена
     port4_stat=0;         //клапан отбора голов открыт
     port5_stat=0;         //клапан пароголов/тело открыт
    
      if (procStTime+Pz2*60 < timer) {process++;procStTime=timer;} //таймер Pz2
      else {
           
           if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}
             }
            break;
            
            case 10:   //отбираем полутелоPz10 минут
     
     myservo.write(sX);    //заслонка пара в рабочем положении
     port1_stat=1;         //разгонный тэн отключён
      port2_stat=0;        //рабочий тэн включён
      port3_stat=0;        //вода включена
     port4_stat=1;         //клапан отбора голов закрыт
     port5_stat=0;         //клапан пароголов/тело открыт
    
      if (procStTime+Pz10*60 < timer) {process++;procStTime=timer;} //таймер Pz10
      else {
           
           if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}
             }
            break;
     
    /*  case 5:      //Отбираем головы короткие Pz2 минут
                      
       if (f<1){ process++;} //если температура охл.жидкости в норме,рабочий тен включён
           else {   myservo.write(sr);                   //заслонка пара закрыта
     port1_stat=1;       //разгонный тэн отключён
     port4_stat=0;       //клапан отбора голов открыт
     if (procStTime+Pz4*60 < timer) {process++;} //таймер Pz2
      else {
           
            if (T[2]<=Tr3){ port2_stat=0;} //если температура охл.жидкости в норме,рабочий тен включён
           else { Stop=1;}
            if (T[0]<=Tr1){ port2_stat=0;}//если температура куба меньшеТr1 рабочий тен включён
            else { Stop=2;}
             if (T[1]>=5){ port3_stat=0;}//если температура 1/3 царги больше50С клапан охл.жидк. включён
            else { port3_stat=1;}
           
            }      
          }                  
     
           
     break;*/
     
 
     case 11:  
     //замеряем пороговую температуру
      myservo.write(sX);    //заслонка пара открыта
     port1_stat=1;         //разгонный тэн отключён
      port2_stat=0;        //рабочий тэн включён
      port3_stat=0;        //вода включена
     port4_stat=1;         //клапан отбора голов закрыт
     port5_stat=0;         //клапан пароголов/тело открыт
    X= (T[1]);           // замеряли пороговою температуру Х 
    Serial.println(X );
    process++;
     
 
     case 12:     //рабочий процесс
                      //работаем по пороговой переменной Х+?в 1/3 колонны,до достижения Tr1 в кубе
           
          
        //Serial.println(X   );
        // Serial.println(" " );
        //Serial.print(Q   );
        // Serial.print("  " );
        // Serial.print(J   );
        //Serial.print(" " );
         
     Q=X+Z; //ПЕРЕМЕННАЯ СТОПА
           J=X+V;//ПЕРЕМЕННАЯ ЗАСЛОНКИ ПАРА     
         
     port1_stat=1;       //разгонный тэн отключён
     port2_stat=0;       //рабочий тэн включён
     port3_stat=0;       //вода открыта 
     port4_stat=1;        //клапан отбора голов закрыт
     port5_stat=1;        //клапан пароголов/тело закрыт
     if (T[1]<=J) {myservo.write(sX);}//если температура в 1/3 ниже пороговой,заслонка открыта
     else 
       myservo.write(sr);//если выше,закрыта
         if (T[2]<=Tr3){ process;} //если температура охл.жидкости в норме,работаем
           else { Stop=1;}
            if (T[0]<=Tr1){ process;}//если температура куба меньшеТr1работаем
            else process++;
            
            if (T[1]<=Q){ process;}//если 1/3 меньшеQ работаем
            else { Stop=3;}
            break;
 
     case 13:  //процес завершён
      myservo.write(sr);                   //заслонка пара закрыта
     port1_stat=1;       //разгонный тэн отключён
     port2_stat=1;       //рабочий тен отключён
     port3_stat=1;       //клапан охл.жидкости закрыт
     port4_stat=1;       //клапан отбора голов закрыт
     port5_stat=1;
     lcd.setCursor(0,1); lcd.print("Pocess zakonchen"); //tone(buzzer, 1000); delay(1000); noTone(buzzer);
           
     break;
  
   
    } 
    digitalWrite(port1, port1_stat);
     digitalWrite(port2,port2_stat);
     digitalWrite(port3,port3_stat);
     digitalWrite(port4,port4_stat);
     digitalWrite(port5,port5_stat);
   
    }
      Menu(0);
  
  }

int button () {
    butPush = 1; // код нажатой кнопки
    exitMenu=1;  // переменная разрешающая продолжение цикла опроса
    if (keysound) {tone(buzzer, 1000);}
    while(exitMenu) {
   val = analogRead(butPin);  // читаем АЦП порта кнопок (значение от 0 до 1023)
    if (val > (butval[5]-butsens) && val < (butval[5]+butsens)) {butPush = 5;}  
    if (val > (butval[4]-butsens) && val < (butval[4]+butsens)) {butPush = 4;}
    if (val > (butval[3]-butsens) && val < (butval[3]+butsens)) {butPush = 3;}
    if (val > (butval[2]-butsens) && val < (butval[2]+butsens)) {butPush = 2;}
    if (val > (butval[1]-butsens) && val < (butval[1]+butsens)) {butPush = 1;}
    butRel=0;
    delay(10);  // задержка для устранения дребезга контактов
    if (val < 1000 && butPush > 0) {exitMenu=0;} // если кнопка была нажата а затем отпущена,
    // то выходим из цикла опроса
    }
    noTone(buzzer);
  return butPush;
}

void printTimer () {
       if (process == 1 ) {
       lcd.print(" __:__"); }
       else {
          switch (process) {
            
           case 2:
           timer=Pz4*60+procStTime-timer;
           break; 
           
           case 3:
           timer=Pz5*60+procStTime-timer;
           break; 
           
           case 4:
           timer=Pz6*60+procStTime-timer;
          break; 
          
          case 5:
           timer=Pz7*60+procStTime-timer;
           break; 
           
           case 6:
           timer=Pz8*60+procStTime-timer;
           break; 
           
           case 7:
           timer=Pz9*60+procStTime-timer;
           break; 
           
           case 8:
           timer=Pz1*60+procStTime-timer;
           break; 
           
           case 9:
           timer=Pz2*60+procStTime-timer;
           break; 
           
           case 10:
           timer=Pz10*60+procStTime-timer;
           break; 
          }
         n=timer/60;
         if (n < 100) lcd.print(" "); 
         if (n < 10) lcd.print(" "); 
         lcd.print(n,DEC);
         lcd.print(":"); 
         n=timer-(timer/60)*60;
         if (n < 10) lcd.print("0"); 
         lcd.print(n,DEC);    
       } 
}
byte write_DS() {
  for (i=0; i<8; i++) {
    if (m==0) {EEPROM.write(128+t*8+i,0);}
    else {EEPROM.write(128+t*8+i,addr[m-1][i]);}
    }
  return 0;
}

void Menu(int butPush) {
    lcd.clear();
    switch (menu) { 
      case 0:
      lcd.print("setting Click ^");
        
        lcd.setCursor(0,1);
        lcd.print("< menu > 3 point");
       if (butPush == 2) {menu=4; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 1) {menu=20; Menu(0);}
        if (butPush == 5) {menu=40; Menu(0);}
        break;
      
      
      case 1: // основной экран, показываем температуру, шаг, на котором находится программа, и  таймер
          lcd.print("Cub ");
          lcd.print(T[1]); // температура
          lcd.setCursor(10,0);
          if ((Stop)) {lcd.clear();lcd.print("ERROR");} else  {
          {lcd.print("normal");}
          // if ((Stop=2)) {lcd.print("ER");} else  {lcd.print("normal");}
          lcd.setCursor(0,1);
          switch (process) {
            case 0: {
              lcd.print("Stop"); 
              break;
              }
           case 1: {
       lcd.print("^"); 
        lcd.print(T[1]); 
        break;
          }
          case 2: {
        lcd.print("1 zatop"); 
       // lcd.print(T[1]); 
        break;
          }
          case 3: {
        lcd.print("1 orash"); 
       // lcd.print(T[1]); 
        break;
          }   
         case 4: {
        lcd.print("2 zatop"); 
      //  lcd.print(T[1]); 
        break;
          }        
          case 5: {
        lcd.print("2 orash"); 
       // lcd.print(T[1]); 
        break;
          }
        case 6: {
        lcd.print("3 zatop"); 
        //lcd.print(T[1]); 
        break;
        }
        case 7: {
        lcd.print("3 orash"); 
        //lcd.print(T[1]); 
        break;
         }
          case 8: {
        lcd.print("3 nasby"); 
       // lcd.print(T[1]); 
        break;
        }
        
        case 9: {
        lcd.print(" glv"); 
       // lcd.print(T[1]); 
        break;
        }
        case 10: {
        lcd.print("plt"); 
        lcd.print(T[1]); 
        break;
        }  
         case 11: {
        lcd.print("x"); 
        lcd.print(X); 
        break;
        }
          
          case 12: {
        lcd.print("gonim"); 
        lcd.print(T[1]); 
        break;
        }
         case 13: lcd.clear();
          {
        lcd.print("proces zakonchen ");
        lcd.setCursor(0,1); 
        lcd.print("lalalaala"); 
        break;
        }
        
        }
       printTimer();   
     }
        
       
        if (butPush == 1) {menu=20; Menu(0);}
        if (butPush == 2) {menu=4; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
       // if (butPush == 4) {menu=54; Menu(0);}
      break;

    case 2:
      if ((Stop)) {lcd.clear();lcd.print("ERROR");} else  {lcd.print("1:");
        lcd.print(T[0]);
        lcd.setCursor(8,0);
        lcd.print("2:");
        lcd.print(T[1]);
        lcd.setCursor(0,1);
        lcd.print("3:");
        lcd.print(T[2]);
        lcd.setCursor(8,1);
        lcd.print("4:");
        lcd.print(T[3]);}
 
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
        if (butPush == 1) {menu=20; Menu(0);}
        break;
        
        case 3:
        if ((Stop)) {lcd.clear();lcd.print("ERROR");} else  {lcd.print("CUB");
        lcd.print(T[0]);
        lcd.setCursor(8,0);
        lcd.print("1/3");
        lcd.print(T[1]);
        lcd.setCursor(0,1);
        lcd.print("X");
        lcd.print(X);
        lcd.setCursor(8,1);
        lcd.print("J");
        lcd.print(J);}
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
        if (butPush == 1) {menu=20; Menu(0);}
        break;
        
      case 4: // запуск процесса
        if (process) {
          lcd.print("Process active");
          lcd.setCursor(0,1);
          timer=timer-StTime;
          lcd.print(timer/60);
          lcd.print(":"); 
          n=timer-(timer/60)*60;
          if (n < 10) lcd.print("0"); 
          lcd.print(n,DEC);   
         }
        else {lcd.print("Process stopped");
      lcd.setCursor(0,1);
      lcd.print("pres 3 start");
    }
         if (butPush == 2) {menu--; Menu(0);}
       // if (butPush == 2) {process--; Menu(0);}
        if (butPush == 3) {
        if (running) {process=0; Menu(0);}
        else {running=1; process=1; StTime=timer;  Menu(0);}    }
        //if (butPush == 4) {process++; Menu(0);}
        if (butPush == 4) {menu=1; Menu(0);}
      break;      

      case 20: // меню настроек
        lcd.print("nastroyki  < >");
        lcd.setCursor(0,1);
        lcd.print("Click 3 exit");
        if (butPush == 2) {menu=30; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      //  if (butPush == 5) {menu=0; Menu(0);}
      break;      
      
      case 21: // меню настроек
        lcd.print("Key Sound");
        lcd.setCursor(0,1);
        if (keysound) {lcd.print("    Enabled");}
        else  {lcd.print("    Disabled");}
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 1 || butPush == 5) {keysound=!keysound; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;      

      case 22: // меню настроек
        lcd.print("Key sensitive");
        lcd.setCursor(0,1);
        lcd.print(butsens, DEC);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {butsens--; Menu(0);}
        if (butPush == 1) {butsens++; Menu(0);}                
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break; 
      
      case 23: // поиск датчиков
        i = 0;
        n=0;
        while (i != 1 ) /// ищем датчики 
        {
          if ( ds.search(addr[n]) != 1) {
            ds.reset_search();
            i = 1; }
          else { 
            n++; 
            TotalDS = n;
          }
        }
        lcd.print("Poisk datchikov");
        lcd.setCursor(0,1);
        lcd.print(n, DEC);
        lcd.print(" Naydeno Click1");
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 1) {menu=100; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;
      
      case 24: 
        
        lcd.print("porog otkl:");
        lcd.setCursor(0,1);
        lcd.print(Z);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Z=Z-0,1; Menu(0);}
        if (butPush == 1) {Z=Z+0,1; Menu(0);}
        if (butPush == 4) {menu++;Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;
      
    case 25: 
        
        lcd.print("porog otbora:");
        lcd.setCursor(0,1);
        lcd.print(V);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {V=V-0.1; Menu(0);}
        if (butPush == 1) {V=V+0.1; Menu(0);}
        if (butPush == 4) {menu++;Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;
      
      case 26: 
        // настройка температуры дефлегматора,при превышении которой 
              // срабатывает аварийный стоп при отключении охл.жидкости
        lcd.print("net vody:");
        lcd.setCursor(0,1);
        lcd.print(Tr3);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Tr3--; Menu(0);}
        if (butPush == 1) {Tr3++; Menu(0);}
        if (butPush == 4) {menu++;Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;

      case 27: 
     // настройка времяни отбора голов
        lcd.print("golovi:");
        lcd.setCursor(0,1);
        lcd.print(Pz2);
        lcd.print(":00");
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Pz2--; Menu(0);}
        if (butPush == 1) {Pz2++; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;      
      
      case 28: 
      // настройка порога включения охл.жидкости
         lcd.print("t ohl:");
        lcd.setCursor(0,1);
        lcd.print(Tr2);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Tr2--; Menu(0);}
        if (butPush == 1) {Tr2++; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;

      case 29: 
     // настройка времяни работы на себя
         lcd.print("rabota na seby:");
        lcd.setCursor(0,1);
        lcd.print(Pz1);
        lcd.print(":00");
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Pz1--; Menu(0);}
        if (butPush == 1) {Pz1++; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;
      
      case 30: //Максимальная температура в кубе
       lcd.print("Cub Temp:");
        lcd.setCursor(0,1);
        lcd.print(Tr1);
        if (butPush == 2) {menu--; Menu(0);}
        if (butPush == 5) {Tr1--; Menu(0);}
        if (butPush == 1) {Tr1++; Menu(0);}
        if (butPush == 4) {menu=20; Menu(0);}
        if (butPush == 3) {menu=1; Menu(0);}
      break;
      
      
      case 40:
      lcd.print("chto gonim? ^");
        
        lcd.setCursor(0,1);
        lcd.print(" menu > 3 point");
       if (butPush == 3) {menu=1; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        if (butPush == 2) {menu=42; Menu(0);}
        break;
        
        
      case 41:
        lcd.print("rektifikat");
        lcd.setCursor(0,1);
        lcd.print("^ da|||net >");
        if (butPush == 1) {{f=0;running=1; process=1; StTime=timer;menu=1;  Menu(0);}}
       if (butPush == 3) {menu=1; Menu(0);}
        if (butPush == 4) {menu++; Menu(0);}
        break;

        case 42:
        lcd.print("2rektifikat");
        lcd.setCursor(0,1);
        lcd.print("^ da|||net >");
        if (butPush == 1) {{f=3;running=1; process=1; StTime=timer;menu=1;  Menu(0);}}
       if (butPush == 3) {menu=1; Menu(0);}
        if (butPush == 4) {menu=40; Menu(0);}
        break;

         case 100: // меню настроек датчиков DS1820
        lcd.print("T");
        lcd.print(t+1,DEC);
        lcd.setCursor(0,1);
        if (m==0) {lcd.print("Netu");}
           else {lcd.print(T[m-1],DEC);}
        if (butPush == 1) {if (t==0) {menu=101;} else {t--;} Menu(0);}
        if (butPush == 2) {if (m==0) {} else {m--;} Menu(0);}
        if (butPush == 3) {write_DS(); lcd.setCursor(0,1); lcd.print("Zapisano v EEPROM"); tone(buzzer, 1000); delay(1000); noTone(buzzer); menu=100; Menu(0);}
        if (butPush == 4) {m++; if (m>(TotalDS)) {m=TotalDS;} Menu(0);}
        if (butPush == 5) {if (t==3) {menu=101;} else {t++;}  Menu(0);}
      break; 

      case 101: // Выход из меню
        lcd.print("Vyiyti iz menu");
        lcd.setCursor(0,1);
        lcd.print("OK dly vihoda");
       
        if (butPush == 3) {menu=23; Menu(0);}
        
      break;      



    } // end switch

}


